/****************************************************************************
 *
 *   File: timers.h:
 *   
 *   Author: Mark Stephenson
 *   Date: Thu Oct  9 18:09:52 2003
 *
 *   Function: This library includes a function that starts timing when
 *      __measure_loop_start() is called, and stops and reports timing 
 *      when __measure_loop_stop() is called.
 *
 ***************************************************************************/

#ifndef cg_loop_lib_INCLUDED
#define cg_loop_lib_INCLUDED

// ------------------------------------------------------------------    
// List of functions for measuring loop runtime.
void __measure_loop_init (char*, signed int);
void __measure_loop_final (char*, signed int);

void __measure_loop_start (signed int);
void __measure_loop_stop (signed int);

struct _loop_timer_t
{
  unsigned long int last;
  unsigned long int cum;
};

extern char *_loop_exec_name;

#endif

